unit modul_ram;

{$mode objfpc}

interface

uses
  Classes, SysUtils;


type


  Tmod_ram = class(TObject)

    constructor Create; overload;
    destructor Destroy; override;

  private
    Mem : Array [0..65535] of Byte;

  public

    procedure RAM_loeschen; { Loeschen des gesammten RAMs }

    function  Read_Byte(Adress : Word) : Byte; { ein Byte aus dem Speicher lesen }
    procedure Write_Byte(Adress : Word; Data : Byte); { ein Byte in den Speicher schreiben }

  end; // Tmod_ram = class(TObject)




var
  mod_ram: Tmod_ram;



implementation




constructor Tmod_ram.Create;
begin
  inherited Create;

end; { constructor Tmod_ram.Create }






procedure Tmod_ram.RAM_loeschen; { Loeschen des gesammten RAMs }
var
  M_Zaehler : Integer;
begin

  for M_Zaehler:=0 to 65535 do
    Mem[M_Zaehler]:=0;

end; { procedure Tmod_ram.RAM_loeschen }







function Tmod_ram.Read_Byte(Adress : Word) : Byte; { ein Byte aus dem Speicher lesen }
begin
  Result:=Mem[Adress];

end; { function Tmod_ram.Read_Byte }



procedure Tmod_ram.Write_Byte(Adress : Word; Data : Byte); { ein Byte in den Speicher schreiben }
begin
  Mem[Adress]:=Data;
end; { procedure Tmod_ram.Write_Byte }





destructor Tmod_ram.Destroy;
begin

  inherited Destroy;
end; { destructor Tmod_ram.Destroy }



end.

_Byte(RW_VECTOR);
   